diff --git a/gcc/analyzer/region-model.cc b/gcc/analyzer/region-model.cc
index 890f7006fee..292d268300d 100644
--- a/gcc/analyzer/region-model.cc
+++ b/gcc/analyzer/region-model.cc
@@ -2361,100 +1830,41 @@ region2::get_desc (bool simple) const
 /* FIXME.  */
 
 void
-region2::accept (visitor *v) const
+region::accept (visitor *v) const
 {
   v->visit_region (this);
   if (m_parent)
     m_parent->accept (v);
 }
 
-/* Base implementation of region2::validate vfunc.
-   Assert that the fields of "region2" are valid; subclasses should
-   chain up their implementation to this one.  */
-#if 0
-void
-region2::validate (const region_model2 &model) const
-{
-  m_parent_reg.validate (model);
-  m_sval_id.validate (model);
-  unsigned i;
-  region2_id *view_reg;
-  FOR_EACH_VEC_ELT (m_view_regs, i, view_reg)
-    {
-      gcc_assert (!view_reg->null_p ());
-      view_reg->validate (model);
-    }
-  m_active_view_reg.validate (model);
-}
-#endif
-
-#if 0
-/* Add a new region2 with id VIEW_REG as a view of this region2.  */
-
-void
-region2::add_view (region2_id view_reg, region_model2 *model)
-{
-  gcc_assert (!view_reg.null_p ());
-  region2 *new_view = model->get_region2 (view_reg);
-  new_view->m_is_view = true;
-  gcc_assert (!new_view->m_parent_reg.null_p ());
-  gcc_assert (new_view->m_sval_id.null_p ());
-
-  //gcc_assert (new_view->get_type () != NULL_TREE);
-  // TODO: this can sometimes be NULL, when viewing through a (void *)
-
-  // TODO: the type ought to not be present yet
-
-  m_view_regs.safe_push (view_reg);
-}
-
-/* Look for a view of type TYPE of this region2, returning its id if found,
-   or null otherwise.  */
-
-region2_id
-region2::get_view (tree type, region_model2 *model) const
-{
-  unsigned i;
-  region2_id *view_reg;
-  FOR_EACH_VEC_ELT (m_view_regs, i, view_reg)
-    {
-      region2 *view = model->get_region2 (*view_reg);
-      gcc_assert (view->m_is_view);
-      if (view->get_type () == type)
-	return *view_reg;
-    }
-  return region2_id::null ();
-}
-#endif
-
 /* Return true if this is a symbolic region for deferencing an
    unknown ptr.
    We shouldn't attempt to bind values for this region (but
    can unbind values for other regions).  */
 
 bool
-region2::symbolic_for_unknown_ptr_p () const
+region::symbolic_for_unknown_ptr_p () const
 {
-  if (const symbolic_region2 *sym_reg = dyn_cast_symbolic_region2 ())
-    if (sym_reg->get_pointer ()->get_kind () == svalue2::SK_UNKNOWN)
+  if (const symbolic_region *sym_reg = dyn_cast_symbolic_region ())
+    if (sym_reg->get_pointer ()->get_kind () == svalue::SK_UNKNOWN)
       return true;
   return false;
 }
 
-/* region2's ctor.  */
+/* region's ctor.  */
 
-region2::region2 (complexity c, unsigned id, const region2 *parent, tree type)
+region::region (complexity c, unsigned id, const region *parent, tree type)
 : m_complexity (c), m_id (id), m_parent (parent), m_type (type),
   m_cached_offset (NULL)
 {
   gcc_assert (type == NULL_TREE || TYPE_P (type));
 }
 
-/* Base implementation of region2::add_to_hash vfunc; subclasses should
+/* Base implementation of region::add_to_hash vfunc; subclasses should
    chain up to this.  */
 
 void
-region2::add_to_hash (inchash::hash &hstate) const
+region::add_to_hash (inchash::hash &hstate) const
 {
   /* We deliberatly omit the id, to avoid different IDs preventing
      consolidation.  */
@@ -2465,18 +1875,18 @@ region2::add_to_hash (inchash::hash &hstate) const
 /* FIXME.  */
 
 int
-region2::cmp_ptrs (const void *p1, const void *p2)
+region::cmp_ptrs (const void *p1, const void *p2)
 {
-  const region2 * const *reg1 = (const region2 * const *)p1;
-  const region2 * const *reg2 = (const region2 * const *)p2;
+  const region * const *reg1 = (const region * const *)p1;
+  const region * const *reg2 = (const region * const *)p2;
 
   return cmp_ids (*reg1, *reg2);
 }
 
-/* Determine if a pointer to this region2 must be non-NULL.
+/* Determine if a pointer to this region must be non-NULL.
 
-   Generally, pointers to region2s must be non-NULL, but pointers
-   to symbolic_region2s might, in fact, be NULL.
+   Generally, pointers to regions must be non-NULL, but pointers
+   to symbolic_regions might, in fact, be NULL.
 
    This allows us to simulate functions like malloc and calloc with:
    - only one "outcome" from each statement,
@@ -2486,15 +1896,15 @@ region2::cmp_ptrs (const void *p1, const void *p2)
    - to be able to zero-fill for calloc.  */
 
 bool
-region2::non_null_p (const region_model2 &model) const
+region::non_null_p (const region_model &model) const
 {
 #if 1
-  /* FIXME: malloc is now simulated via a heap_allocated_region2.
+  /* FIXME: malloc is now simulated via a heap_allocated_region.
      That said, maybe we do want the possibilty of NULL for symbolic
      regions too.  */
-  /* Are we within a symbolic_region2?  If so, it could be NULL, and we
+  /* Are we within a symbolic_region?  If so, it could be NULL, and we
      have to fall back on the constraints.  */
-  if (const symbolic_region2 *sym_reg = dyn_cast_symbolic_region2 ())
+  if (const symbolic_region *sym_reg = dyn_cast_symbolic_region ())
     {
       return false; // TODO: really?
     }
@@ -2610,9 +2020,9 @@ tree_cmp (const void *p1, const void *p2)
   return tree_cmp (t1, t2);
 }
 
-/* class frame_region2 : public space_region2.  */
+/* class frame_region : public space_region.  */
 
-frame_region2::~frame_region2 ()
+frame_region::~frame_region ()
 {
   for (map_t::iterator iter = m_locals.begin ();
        iter != m_locals.end ();
@@ -2621,32 +2031,32 @@ frame_region2::~frame_region2 ()
 }
 
 void
-frame_region2::accept (visitor *v) const
+frame_region::accept (visitor *v) const
 {
-  region2::accept (v);
+  region::accept (v);
   if (m_calling_frame)
     m_calling_frame->accept (v);
 }
 
 void
-frame_region2::dump_to_pp (pretty_printer *pp, bool simple) const
+frame_region::dump_to_pp (pretty_printer *pp, bool simple) const
 {
   if (simple)
     pp_printf (pp, "frame: %qs@%i", function_name (m_fun), get_stack_depth ());
   else
-    pp_printf (pp, "frame_region2(%qs, index: %i, depth: %i)",
+    pp_printf (pp, "frame_region(%qs, index: %i, depth: %i)",
 	       function_name (m_fun), m_index, get_stack_depth ());
 }
 
-/* Compare the fields of this frame_region2 with OTHER, returning true
+/* Compare the fields of this frame_region with OTHER, returning true
    if they are equal.
-   For use by region2::operator==.  */
+   For use by region::operator==.  */
 
 bool
-frame_region2::compare_fields (const frame_region2 &other) const
+frame_region::compare_fields (const frame_region &other) const
 {
 #if 0
-  if (!map_region2::compare_fields (other))
+  if (!map_region::compare_fields (other))
     return false;
 #endif
   if (m_fun != other.m_fun)
@@ -2659,19 +2069,19 @@ frame_region2::compare_fields (const frame_region2 &other) const
   return true;
 }
 
-/* Implementation of region2::add_to_hash vfunc for frame_region2.  */
+/* Implementation of region::add_to_hash vfunc for frame_region.  */
 #if 0
 void
-frame_region2::add_to_hash (inchash::hash &hstate) const
+frame_region::add_to_hash (inchash::hash &hstate) const
 {
-  map_region2::add_to_hash (hstate);
+  map_region::add_to_hash (hstate);
   hstate.add_ptr (m_fun);
   hstate.add_int (m_depth);
 }
 #endif
 
-const region2 *
-frame_region2::get_region_for_local (region_model2_manager *mgr,
+const region *
+frame_region::get_region_for_local (region_model_manager *mgr,
 				     tree expr) const
 {
   // TODO: could also check that VAR_DECLs are locals
@@ -2684,29 +2094,29 @@ frame_region2::get_region_for_local (region_model2_manager *mgr,
   // TODO: when is it available?
   map_t &mutable_locals = const_cast <map_t &> (m_locals);
 
-  if (region2 **slot = mutable_locals.get (expr))
+  if (region **slot = mutable_locals.get (expr))
     return *slot;
-  decl_region2 *reg
-    = new decl_region2 (mgr->alloc_region_id (), this, expr);
+  decl_region *reg
+    = new decl_region (mgr->alloc_region_id (), this, expr);
   mutable_locals.put (expr, reg);
   return reg;
 }
 
-/* class globals_region2 : public space_region2.  */
+/* class globals_region : public space_region.  */
 
-/* Compare the fields of this globals_region2 with OTHER, returning true
+/* Compare the fields of this globals_region with OTHER, returning true
    if they are equal.
-   For use by region2::operator==.  */
+   For use by region::operator==.  */
 #if 0
 bool
-globals_region2::compare_fields (const globals_region2 &other) const
+globals_region::compare_fields (const globals_region &other) const
 {
-  return map_region2::compare_fields (other);
+  return map_region::compare_fields (other);
 }
 #endif
 
 void
-globals_region2::dump_to_pp (pretty_printer *pp, bool simple) const
+globals_region::dump_to_pp (pretty_printer *pp, bool simple) const
 {
   if (simple)
     pp_string (pp, "::");
@@ -2714,47 +2124,47 @@ globals_region2::dump_to_pp (pretty_printer *pp, bool simple) const
     pp_string (pp, "globals");
 }
 
-/* class code_region2 : public map_region2.  */
+/* class code_region : public map_region.  */
 
-/* Compare the fields of this code_region2 with OTHER, returning true
+/* Compare the fields of this code_region with OTHER, returning true
    if they are equal.
-   For use by region2::operator==.  */
+   For use by region::operator==.  */
 #if 0
 bool
-code_region2::compare_fields (const code_region2 &other) const
+code_region::compare_fields (const code_region &other) const
 {
-  return map_region2::compare_fields (other);
+  return map_region::compare_fields (other);
 }
 #endif
 
 /* FIXME.  */
 
 void
-code_region2::dump_to_pp (pretty_printer *pp, bool simple) const
+code_region::dump_to_pp (pretty_printer *pp, bool simple) const
 {
   if (simple)
     pp_string (pp, "code region");
   else
-    pp_string (pp, "code_region2()");
+    pp_string (pp, "code_region()");
 }
 
-/* class function_region2 : public region2.  */
+/* class function_region : public region.  */
 
-/* Compare the fields of this function_region2 with OTHER, returning true
+/* Compare the fields of this function_region with OTHER, returning true
    if they are equal.
-   For use by region2::operator==.  */
+   For use by region::operator==.  */
 #if 0
 bool
-function_region2::compare_fields (const function_region2 &other) const
+function_region::compare_fields (const function_region &other) const
 {
-  return map_region2::compare_fields (other);
+  return map_region::compare_fields (other);
 }
 #endif
 
 /* FIXME.  */
 
 void
-function_region2::dump_to_pp (pretty_printer *pp, bool simple) const
+function_region::dump_to_pp (pretty_printer *pp, bool simple) const
 {
   if (simple)
     {
@@ -2762,18 +2172,18 @@ function_region2::dump_to_pp (pretty_printer *pp, bool simple) const
     }
   else
     {
-      pp_string (pp, "function_region2(");
+      pp_string (pp, "function_region(");
       dump_quoted_tree (pp, m_fndecl);
       pp_string (pp, ")");
     }
 }
 
-/* class label_region2 : public region2.  */
+/* class label_region : public region.  */
 
 /* FIXME.  */
 
 void
-label_region2::dump_to_pp (pretty_printer *pp, bool simple) const
+label_region::dump_to_pp (pretty_printer *pp, bool simple) const
 {
   if (simple)
     {
@@ -2781,418 +2191,124 @@ label_region2::dump_to_pp (pretty_printer *pp, bool simple) const
     }
   else
     {
-      pp_string (pp, "label_region2(");
+      pp_string (pp, "label_region(");
       dump_quoted_tree (pp, m_label);
       pp_string (pp, ")");
     }
 }
 
-/* class stack_region2 : public region2.  */
+/* class stack_region : public region.  */
 
 void
-stack_region2::dump_to_pp (pretty_printer *pp, bool simple) const
+stack_region::dump_to_pp (pretty_printer *pp, bool simple) const
 {
   if (simple)
     pp_string (pp, "stack region");
   else
-    pp_string (pp, "stack_region2()");
+    pp_string (pp, "stack_region()");
 }
 
-/* Compare the fields of this stack_region2 with OTHER, returning true
+/* Compare the fields of this stack_region with OTHER, returning true
    if they are equal.
-   For use by region2::operator==.  */
+   For use by region::operator==.  */
 #if 0
 bool
-stack_region2::compare_fields (const stack_region2 &other) const
+stack_region::compare_fields (const stack_region &other) const
 {
   if (m_frame_regs.length () != other.m_frame_regs.length ())
     return false;
 
-  int i;
-  region2_id *frame_reg;
-  FOR_EACH_VEC_ELT (m_frame_regs, i, frame_reg)
-    if (m_frame_regs[i] != other.m_frame_regs[i])
-      return false;
-
-  return true;
-}
-#endif
-
-/* Implementation of region2::add_to_hash vfunc for stack_region2.  */
-#if 0
-void
-stack_region2::add_to_hash (inchash::hash &hstate) const
-{
-  region2::add_to_hash (hstate);
-
-  int i;
-  region2_id *frame_reg;
-  FOR_EACH_VEC_ELT (m_frame_regs, i, frame_reg)
-    inchash::add (*frame_reg, hstate);
-}
-#endif
-
-/* Attempt to merge STACK_REGION2_A and STACK_REGION2_B using MERGER.
-   Return true if the merger is possible, false otherwise.  */
-#if 0
-bool
-stack_region2::can_merge_p (const stack_region2 *stack_region2_a,
-			   const stack_region2 *stack_region2_b,
-			   model_merger *merger)
-{
-  if (stack_region2_a->get_num_frames ()
-      != stack_region2_b->get_num_frames ())
-    return false;
-
-  region_model2 *merged_model = merger->m_merged_model;
-
-  region2_id rid_merged_stack
-    = merged_model->get_root_region2 ()->ensure_stack_region2 (merged_model);
-
-  stack_region2 *merged_stack
-    = merged_model->get_region2 <stack_region2> (rid_merged_stack);
-
-  /* First, create all frames in the merged model, without populating them.
-     The merging code assumes that all frames in the merged model already exist,
-     so we have to do this first to handle the case in which a local in an
-     older frame points at a local in a more recent frame.  */
-    for (unsigned i = 0; i < stack_region2_a->get_num_frames (); i++)
-      {
-	region2_id rid_a = stack_region2_a->get_frame_reg (i);
-	frame_region2 *frame_a = merger->get_region2_a <frame_region2> (rid_a);
-
-	region2_id rid_b = stack_region2_b->get_frame_reg (i);
-	frame_region2 *frame_b = merger->get_region2_b <frame_region2> (rid_b);
-
-	if (frame_a->get_function () != frame_b->get_function ())
-	  return false;
-
-	frame_region2 *merged_frame = new frame_region2 (rid_merged_stack,
-						       frame_a->get_function (),
-						       frame_a->get_depth ());
-	region2_id rid_merged_frame = merged_model->add_region2 (merged_frame);
-	merged_stack->push_frame (rid_merged_frame);
-      }
-
-    /* Now populate the frames we created.  */
-    for (unsigned i = 0; i < stack_region2_a->get_num_frames (); i++)
-      {
-	region2_id rid_a = stack_region2_a->get_frame_reg (i);
-	frame_region2 *frame_a = merger->get_region2_a <frame_region2> (rid_a);
-
-	region2_id rid_b = stack_region2_b->get_frame_reg (i);
-	frame_region2 *frame_b = merger->get_region2_b <frame_region2> (rid_b);
-
-	region2_id rid_merged_frame = merged_stack->get_frame_reg (i);
-	frame_region2 *merged_frame
-	  = merged_model->get_region2 <frame_region2> (rid_merged_frame);
-	if (!map_region2::can_merge_p (frame_a, frame_b,
-				      merged_frame, rid_merged_frame,
-				      merger))
-	  return false;
-      }
-
-  return true;
-}
-#endif
-
-/* For debugging purposes: look for a grandchild region2 within one of
-   the child frame region2s, where the grandchild is for a decl named
-   IDENTIFIER (or an SSA_NAME for such a decl):
-
-     stack_region2
-     `-frame_region2
-       `-region2 for decl named IDENTIFIER
-
-   returning its value, or svalue2_id::null if none are found.  */
-#if 0
-svalue2_id
-stack_region2::get_value_by_name (tree identifier,
-				 const region_model2 &model) const
-{
-  int i;
-  region2_id *frame_reg;
-  FOR_EACH_VEC_ELT (m_frame_regs, i, frame_reg)
-    {
-      frame_region2 *frame = model.get_region2<frame_region2> (*frame_reg);
-      const svalue2 *sval = frame->get_value_by_name (identifier, model);
-      if (!sid.null_p ())
-	return sid;
-    }
-
-  return svalue2_id::null ();
-}
-#endif
-
-/* class heap_region2 : public region2.  */
-
-/* Compare the fields of this heap_region2 with OTHER, returning true
-   if they are equal.
-   For use by region2::operator==.  */
-#if 0
-bool
-heap_region2::compare_fields (const heap_region2 &) const
-{
-  /* Empty.  */
-  return true;
-}
-#endif
-
-void
-heap_region2::dump_to_pp (pretty_printer *pp, bool simple) const
-{
-  if (simple)
-    pp_string (pp, "heap region");
-  else
-    pp_string (pp, "heap_region2()");
-}
-
-/* class root_region2 : public region2.  */
-
-/* root_region2's default ctor.  */
-
-root_region2::root_region2 (unsigned id)
-: region2 (complexity (1, 1), id, NULL, NULL_TREE)
-{
-}
-
-#if 0
-/* Compare the fields of this root_region2 with OTHER, returning true
-   if they are equal.
-   For use by region2::operator==.  */
-
-bool
-root_region2::compare_fields (const root_region2 &other) const
-{
-  if (m_stack_reg != other.m_stack_reg)
-    return false;
-  if (m_globals_reg != other.m_globals_reg)
-    return false;
-  if (m_code_reg != other.m_code_reg)
-    return false;
-  if (m_heap_reg != other.m_heap_reg)
-    return false;
-  return true;
-}
-#endif
-
-void
-root_region2::dump_to_pp (pretty_printer *pp, bool simple) const
-{
-  if (simple)
-    pp_string (pp, "root region");
-  else
-    pp_string (pp, "root_region2()");
-}
-
-/* Create a new frame_region2 for a call to FUN and push it onto
-   the stack.
-
-   If ARG_SVALS is non-NULL, use it to populate the parameters
-   in the new frame.
-   Otherwise, populate them with unknown values.
-
-   Return the region2_id of the new frame.  */
-#if 0
-region2_id
-root_region2::push_frame (region_model2 *model, function *fun,
-			 vec<svalue2_id> *arg_svals,
-			 region_model2_context *ctxt)
-{
-  gcc_assert (fun);
-  /* arg_svals can be NULL.  */
-
-  ensure_stack_region2 (model);
-  stack_region2 *stack = model->get_region2 <stack_region2> (m_stack_reg);
-
-  frame_region2 *region2 = new frame_region2 (m_stack_reg, fun,
-					   stack->get_num_frames ());
-  region2_id frame_reg = model->add_region2 (region2);
-
-  // TODO: unify these cases by building a vec of unknown?
-
-  if (arg_svals)
-    {
-      /* Arguments supplied from a caller frame.  */
-
-      tree fndecl = fun->decl;
-      unsigned idx = 0;
-      for (tree iter_parm = DECL_ARGUMENTS (fndecl); iter_parm;
-	   iter_parm = DECL_CHAIN (iter_parm), ++idx)
-	{
-	  /* If there's a mismatching declaration, the call stmt might
-	     not have enough args.  Handle this case by leaving the
-	     rest of the params as uninitialized.  */
-	  if (idx >= arg_svals->length ())
-	    break;
-	  svalue2_id arg_sval = (*arg_svals)[idx];
-	  region2_id parm_reg
-	    = region2->get_or_create (model, frame_reg, iter_parm,
-				     TREE_TYPE (iter_parm), ctxt);
-	  model->set_value (parm_reg, arg_sval, ctxt);
-
-	  /* Also do it for default SSA name (sharing the same unknown
-	     value).  */
-	  tree parm_default_ssa = ssa_default_def (fun, iter_parm);
-	  if (parm_default_ssa)
-	    {
-	      region2_id defssa_reg
-		= region2->get_or_create (model, frame_reg, parm_default_ssa,
-					 TREE_TYPE (iter_parm), ctxt);
-	      model->set_value (defssa_reg, arg_sval, ctxt);
-	    }
-	}
-    }
-  else
-    {
-      /* No known arguments (a top-level call within the analysis).  */
-
-      /* Params have a defined, unknown value; they should not inherit
-	 from the poisoned uninit value.  */
-      tree fndecl = fun->decl;
-      for (tree iter_parm = DECL_ARGUMENTS (fndecl); iter_parm;
-	   iter_parm = DECL_CHAIN (iter_parm))
-	{
-	  region2_id parm_reg
-	    = region2->get_or_create (model, frame_reg, iter_parm,
-				     TREE_TYPE (iter_parm), ctxt);
-	  svalue2_id parm_sval
-	    = model->set_to_new_unknown_value (parm_reg, TREE_TYPE (iter_parm),
-					       ctxt);
-
-	  /* Also do it for default SSA name (sharing the same unknown
-	     value).  */
-	  tree parm_default_ssa = ssa_default_def (fun, iter_parm);
-	  if (parm_default_ssa)
-	    {
-	      region2_id defssa_reg
-		= region2->get_or_create (model, frame_reg, parm_default_ssa,
-					 TREE_TYPE (iter_parm), ctxt);
-	      model->get_region2 (defssa_reg)->set_value (*model, defssa_reg,
-							 parm_sval, ctxt);
-	    }
-	}
-    }
-
-  stack->push_frame (frame_reg);
+  int i;
+  region_id *frame_reg;
+  FOR_EACH_VEC_ELT (m_frame_regs, i, frame_reg)
+    if (m_frame_regs[i] != other.m_frame_regs[i])
+      return false;
+
+  return true;
+}
+#endif
 
-  return frame_reg;
+/* Implementation of region::add_to_hash vfunc for stack_region.  */
+#if 0
+void
+stack_region::add_to_hash (inchash::hash &hstate) const
+{
+  region::add_to_hash (hstate);
+
+  int i;
+  region_id *frame_reg;
+  FOR_EACH_VEC_ELT (m_frame_regs, i, frame_reg)
+    inchash::add (*frame_reg, hstate);
 }
+#endif
 
-/* Return the region2_id of the stack region2, creating it if doesn't
-   already exist.  */
+/* class heap_region : public region.  */
 
-region2_id
-root_region2::ensure_stack_region2 (region_model2 *model)
+/* Compare the fields of this heap_region with OTHER, returning true
+   if they are equal.
+   For use by region::operator==.  */
+#if 0
+bool
+heap_region::compare_fields (const heap_region &) const
 {
-  if (m_stack_reg.null_p ())
-    {
-      svalue2_id uninit_sval
-	= model->add_svalue2 (new poisoned_svalue2 (POISON_KIND_UNINIT,
-						  NULL_TREE));
-      m_stack_reg
-	= model->add_region2 (new stack_region2 (model->get_root_reg (),
-					       uninit_sval));
-    }
-  return m_stack_reg;
+  /* Empty.  */
+  return true;
+}
+#endif
+
+void
+heap_region::dump_to_pp (pretty_printer *pp, bool simple) const
+{
+  if (simple)
+    pp_string (pp, "heap region");
+  else
+    pp_string (pp, "heap_region()");
 }
 
-/* Return the region2_id of the heap region2, creating it if doesn't
-   already exist.  */
+/* class root_region : public region.  */
+
+/* root_region's default ctor.  */
 
-region2_id
-root_region2::ensure_heap_region2 (region_model2 *model)
+root_region::root_region (unsigned id)
+: region (complexity (1, 1), id, NULL, NULL_TREE)
 {
-  if (m_heap_reg.null_p ())
-    {
-      svalue2_id uninit_sval
-	= model->add_svalue2 (new poisoned_svalue2 (POISON_KIND_UNINIT,
-						  NULL_TREE));
-      m_heap_reg
-	= model->add_region2 (new heap_region2 (model->get_root_reg (),
-					      uninit_sval));
-    }
-  return m_heap_reg;
 }
 
-/* Attempt to merge ROOT_REGION2_A and ROOT_REGION2_B into
-   MERGED_ROOT_REGION2 using MERGER.
-   Return true if the merger is possible, false otherwise.  */
+#if 0
+/* Compare the fields of this root_region with OTHER, returning true
+   if they are equal.
+   For use by region::operator==.  */
 
 bool
-root_region2::can_merge_p (const root_region2 *root_region2_a,
-			  const root_region2 *root_region2_b,
-			  root_region2 *merged_root_region2,
-			  model_merger *merger)
-{
-  /* We can only merge if the stacks are sufficiently similar.  */
-  stack_region2 *stack_a = root_region2_a->get_stack_region2 (merger->m_model_a);
-  stack_region2 *stack_b = root_region2_b->get_stack_region2 (merger->m_model_b);
-  if (stack_a && stack_b)
-    {
-      /* If the two models both have a stack, attempt to merge them.  */
-      merged_root_region2->ensure_stack_region2 (merger->m_merged_model);
-      if (!stack_region2::can_merge_p (stack_a, stack_b, merger))
-	return false;
-    }
-  else if (stack_a || stack_b)
-    /* Don't attempt to merge if one model has a stack and the other
-       doesn't.  */
+root_region::compare_fields (const root_region &other) const
+{
+  if (m_stack_reg != other.m_stack_reg)
+    return false;
+  if (m_globals_reg != other.m_globals_reg)
+    return false;
+  if (m_code_reg != other.m_code_reg)
+    return false;
+  if (m_heap_reg != other.m_heap_reg)
     return false;
-
-  map_region2 *globals_a = root_region2_a->get_globals_region2 (merger->m_model_a);
-  map_region2 *globals_b = root_region2_b->get_globals_region2 (merger->m_model_b);
-  if (globals_a && globals_b)
-    {
-      /* If both models have globals region2s, attempt to merge them.  */
-      region2_id merged_globals_reg
-	= merged_root_region2->ensure_globals_region2 (merger->m_merged_model);
-      map_region2 *merged_globals
-	= merged_root_region2->get_globals_region2 (merger->m_merged_model);
-      if (!map_region2::can_merge_p (globals_a, globals_b,
-				    merged_globals, merged_globals_reg,
-				    merger))
-	return false;
-    }
-  /* otherwise, merge as "no globals".  */
-
-  map_region2 *code_a = root_region2_a->get_code_region2 (merger->m_model_a);
-  map_region2 *code_b = root_region2_b->get_code_region2 (merger->m_model_b);
-  if (code_a && code_b)
-    {
-      /* If both models have code region2s, attempt to merge them.  */
-      region2_id merged_code_reg
-	= merged_root_region2->ensure_code_region2 (merger->m_merged_model);
-      map_region2 *merged_code
-	= merged_root_region2->get_code_region2 (merger->m_merged_model);
-      if (!map_region2::can_merge_p (code_a, code_b,
-				    merged_code, merged_code_reg,
-				    merger))
-	return false;
-    }
-  /* otherwise, merge as "no code".  */
-
-  heap_region2 *heap_a = root_region2_a->get_heap_region2 (merger->m_model_a);
-  heap_region2 *heap_b = root_region2_b->get_heap_region2 (merger->m_model_b);
-  if (heap_a && heap_b)
-    {
-      /* If both have a heap, create a "merged" heap.
-	 Actually merging the heap contents happens via the region_svalue2
-	 instances, as needed, when seeing pairs of region_svalue2 instances.  */
-      merged_root_region2->ensure_heap_region2 (merger->m_merged_model);
-    }
-  /* otherwise, merge as "no heap".  */
-
   return true;
 }
 #endif
 
-/* Implementation of region2::add_to_hash vfunc for root_region2.  */
+void
+root_region::dump_to_pp (pretty_printer *pp, bool simple) const
+{
+  if (simple)
+    pp_string (pp, "root region");
+  else
+    pp_string (pp, "root_region()");
+}
+
+/* Implementation of region::add_to_hash vfunc for root_region.  */
 #if 0
 void
-root_region2::add_to_hash (inchash::hash &hstate) const
+root_region::add_to_hash (inchash::hash &hstate) const
 {
-  region2::add_to_hash (hstate);
+  region::add_to_hash (hstate);
   inchash::add (m_stack_reg, hstate);
   inchash::add (m_globals_reg, hstate);
   inchash::add (m_code_reg, hstate);
@@ -3200,38 +2316,38 @@ root_region2::add_to_hash (inchash::hash &hstate) const
 }
 #endif
 
-/* For debugging purposes: look for a descendant region2 for a local
+/* For debugging purposes: look for a descendant region for a local
    or global decl named IDENTIFIER (or an SSA_NAME for such a decl),
-   returning its value, or svalue2_id::null if none are found.  */
+   returning its value, or svalue_id::null if none are found.  */
 #if 0
-svalue2_id
-root_region2::get_value_by_name (tree identifier,
-				const region_model2 &model) const
+svalue_id
+root_region::get_value_by_name (tree identifier,
+				const region_model &model) const
 {
-  if (stack_region2 *stack = get_stack_region2 (&model))
+  if (stack_region *stack = get_stack_region (&model))
     {
-      const svalue2 *sval = stack->get_value_by_name (identifier, model);
+      const svalue *sval = stack->get_value_by_name (identifier, model);
       if (!sid.null_p ())
 	return sid;
     }
-  if (map_region2 *globals = get_globals_region2 (&model))
+  if (map_region *globals = get_globals_region (&model))
     {
-      const svalue2 *sval = globals->get_value_by_name (identifier, model);
+      const svalue *sval = globals->get_value_by_name (identifier, model);
       if (!sid.null_p ())
 	return sid;
     }
-  return svalue2_id::null ();
+  return svalue_id::null ();
 }
 #endif
 
-/* class symbolic_region2 : public map_region2.  */
+/* class symbolic_region : public map_region.  */
 
-/* Compare the fields of this symbolic_region2 with OTHER, returning true
+/* Compare the fields of this symbolic_region with OTHER, returning true
    if they are equal.
-   For use by region2::operator==.  */
+   For use by region::operator==.  */
 
 bool
-symbolic_region2::compare_fields (const symbolic_region2 &other) const
+symbolic_region::compare_fields (const symbolic_region &other) const
 {
   return m_sval_ptr == other.m_sval_ptr;
 }
@@ -3239,16 +2355,16 @@ symbolic_region2::compare_fields (const symbolic_region2 &other) const
 /* FIXME.  */
 
 void
-symbolic_region2::accept (visitor *v) const
+symbolic_region::accept (visitor *v) const
 {
-  region2::accept (v);
+  region::accept (v);
   m_sval_ptr->accept (v);
 }
 
 /* FIXME.  */
 
 void
-symbolic_region2::dump_to_pp (pretty_printer *pp, bool simple) const
+symbolic_region::dump_to_pp (pretty_printer *pp, bool simple) const
 {
   if (simple)
     {
@@ -3258,7 +2374,7 @@ symbolic_region2::dump_to_pp (pretty_printer *pp, bool simple) const
     }
   else
     {
-      pp_string (pp, "symbolic_region2(");
+      pp_string (pp, "symbolic_region(");
       get_parent_region ()->dump_to_pp (pp, simple);
       pp_string (pp, ", ");
       print_quoted_type (pp, get_type ());
@@ -3268,29 +2384,29 @@ symbolic_region2::dump_to_pp (pretty_printer *pp, bool simple) const
     }
 }
 
-/* class decl_region2 : public region2.  */
+/* class decl_region : public region.  */
 
 void
-decl_region2::add_to_hash (inchash::hash &hstate) const
+decl_region::add_to_hash (inchash::hash &hstate) const
 {
-  region2::add_to_hash (hstate);
+  region::add_to_hash (hstate);
   hstate.add_ptr (m_decl);
 }
 
 bool
-decl_region2::compare_fields (const decl_region2 &other) const
+decl_region::compare_fields (const decl_region &other) const
 {
   return m_decl == other.m_decl;
 }
 
 void
-decl_region2::dump_to_pp (pretty_printer *pp, bool simple) const
+decl_region::dump_to_pp (pretty_printer *pp, bool simple) const
 {
   if (simple)
     pp_printf (pp, "%E", m_decl);
   else
     {
-      pp_string (pp, "decl_region2(");
+      pp_string (pp, "decl_region(");
       get_parent_region ()->dump_to_pp (pp, simple);
       pp_string (pp, ", ");
       print_quoted_type (pp, get_type ());
@@ -3301,33 +2417,33 @@ decl_region2::dump_to_pp (pretty_printer *pp, bool simple) const
 /* FIXME.  */
 
 int
-decl_region2::get_stack_depth () const
+decl_region::get_stack_depth () const
 {
   if (get_parent_region () == NULL)
     return 0;
-  if (const frame_region2 *frame_reg
-	= get_parent_region ()->dyn_cast_frame_region2 ())
+  if (const frame_region *frame_reg
+	= get_parent_region ()->dyn_cast_frame_region ())
     return frame_reg->get_stack_depth ();
   return 0;
 }
 
-/* class field_region2 : public region2.  */
+/* class field_region : public region.  */
 
 void
-field_region2::add_to_hash (inchash::hash &hstate) const
+field_region::add_to_hash (inchash::hash &hstate) const
 {
-  region2::add_to_hash (hstate);
+  region::add_to_hash (hstate);
   hstate.add_ptr (m_field);
 }
 
 bool
-field_region2::compare_fields (const field_region2 &other) const
+field_region::compare_fields (const field_region &other) const
 {
   return m_field == other.m_field;
 }
 
 void
-field_region2::dump_to_pp (pretty_printer *pp, bool simple) const
+field_region::dump_to_pp (pretty_printer *pp, bool simple) const
 {
   if (simple)
     {
@@ -3337,7 +2453,7 @@ field_region2::dump_to_pp (pretty_printer *pp, bool simple) const
     }
   else
     {
-      pp_string (pp, "field_region2(");
+      pp_string (pp, "field_region(");
       get_parent_region ()->dump_to_pp (pp, simple);
       pp_string (pp, ", ");
       print_quoted_type (pp, get_type ());
@@ -3345,10 +2461,10 @@ field_region2::dump_to_pp (pretty_printer *pp, bool simple) const
     }
 }
 
-/* class element_region2 : public region2.  */
+/* class element_region : public region.  */
 
 bool
-element_region2::compare_fields (const element_region2 &other) const
+element_region::compare_fields (const element_region &other) const
 {
   return m_index == other.m_index;
 }
